#!/bin/sh

if [ "$1" = "" ]; then
    echo
    echo Usage: $0 projectdir
    echo
    exit 1
fi

if [ "$CATY_HOME" = "" ]; then
    _CATY_HOME=.
else
    _CATY_HOME="$CATY_HOME"
fi

projectdir="$1"
files='_global.xjson stdcaty.py'
dirs='python common lib'

if [ ! -d  "$projectdir" ]; then
    mkdir "$projectdir"
fi
if [ ! -d  "$projectdir" ]; then
    echo
    echo "cannot make directory $projectdir"
    echo
    exit 1
fi

for f in $files; do cp "$_CATY_HOME/$f" "$projectdir"; done
for d in $dirs;  do cp --recursive "$_CATY_HOME/$d" "$projectdir/"; done
