#coding: utf-8
from caty.core.command import Builtin
from caty.core.schema import *
from caty.util import cout
name = u'debug'
schema = u''
class Dump(Builtin):
    command_decl = u"""
        /**
         * 入力値を標準出力に書き出す。それ以外の動作は pass と同じ。
         */
        command dump :: _T -> _T
            refers python:caty.command.debug.Dump;
    """
    def execute(self, input):
        print input
        return input

class DumpSession(Builtin):
    command_decl = u"""
    /**
     * セッションの値をすべて出力する。
     */
     command dump-session :: void -> object
        reads session
        refers python:caty.command.debug.DumpSession;
    """
    def execute(self):
        return self.session._to_dict()['objects']

class GetSession(Builtin):
    command_decl = u"""
    /**
     * セッションから指定されたキーの値を取得する。
     * nullable オプションが指定された場合、キーが見つからなかったときに null を返す。
     */
     command get-session {"nullable": boolean} [string] :: void -> T
        reads session
        refers python:caty.command.debug.GetSession;
    """
    def setup(self, opts, key):
        self.__key = key
        self.__nullable = opts.nullable

    def execute(self):
        try:
            return self.session._to_dict()['objects'][self.__key]
        except:
            if self.__nullable:
                return None
            else:
                raise

class DumpSchema(Builtin):
    command_decl = u"""
    /**
     * スキーマ定義のダンプ
     */
    command dump-schema [string] :: void -> void
        reads schema
        refers python:caty.command.debug.DumpSchema;
    """
    def setup(self, name):
        self.__schema_name = name

    def execute(self):
        print self.schema[self.__schema_name].pp()

