#coding:utf-8
import re
from topdown import *
from caty.core.casm.language.ast import Provide, ModuleName
from caty.core.casm.language.util import *
from caty.core.casm.language.schemaparser import schema
from caty.core.casm.language.commandparser import command
u"""
casm -> head (schema|command)*
head -> provides name (',' name)*
schema -> typedecl | command
typedecl -> 'type' name '=' typedef ';'
typedef -> term op typedef | term
op -> '&' | '|'
term -> ('@' name term | '(' typedef ')' | scalar | enum | object ) ?
scalar -> typename options? underlyingtypes? '?'?
typename -> name | package ':' name
package -> name | name '.' name
options -> '(' optval (',' optval)* ')'
optval -> name '=' value
underlyingtypes -> '[' scalar '*'? (',' scalar '*'?)* ']'
enum -> name '[' value ']' '?'?
value -> string|integer|boolean
string -> '"' .* '"'
integer -> -?[0-9]+
boolean -> 'true' | 'false'
"""
def parse(t):
    try:
        return as_parser(casm).run(t, hook=remove_comment, auto_remove_ws=True)
    except ParseFailed, e:
        raise SchemaSyntaxError(e)

def iparse(t):
    try:
        return (i for i in as_parser(casm).run(t, hook=remove_comment, auto_remove_ws=True))
    except ParseFailed, e:
        raise SchemaSyntaxError(e)

def casm(seq):
    s = []
    #p = option(provides)(seq)
    remove_comment(seq)
    m = module_decl(seq)
    s.append(m)
    #if p:
    #    s.append(p)
    while not seq.eof:
        s.append(seq.parse([try_(schema), try_(command)]))
    remove_comment(seq)
    return s

def module_decl(seq):
    _ = seq.parse('module ')
    n = pkgname(seq)
    _ = seq.parse(';')
    return ModuleName(n)

def pkgname(seq):
    return seq.parse(Regex(r'[a-zA-Z]*([a-zA-Z0-9_.])*'))

def provides(seq):
    _ = seq.parse('provides ')
    names = chain_flat(name, comma)
    return Provide(names)

