#coding:utf-8
import re
from topdown import *
from caty.core.casm.language.ast import *
from caty.core.casm.language.util import *
from caty.core.casm.language.schemaparser import term, typedef, object_, array

def command(seq):
    doc = option(docstring)(seq)
    a = seq.parse(annotation)
    _ = seq.parse('command ')
    n = seq.parse(cmdname)
    patterns = many1(call_pattern)(seq)
    j = seq.parse(many(jump))
    r = seq.parse(many(resource))
    rf = seq.parse(many1(refers))
    _ = seq.parse(';')
    return CommandNode(n, map(lambda p:p(j, r), patterns), rf, doc, a)

def cmdname(seq):
    return seq.parse(Regex(r'[a-zA-Z_](-?[a-zA-Z0-9_]*)*'))

def call_pattern(seq):
    o = option(object_)(seq)
    if o:
        opt = o
    else:
        opt = None
    a = option(array)(seq)
    if a:
        arg = a
    else:
        arg = None
    _ = seq.parse('::')
    d = decl(seq)
    return lambda j, r: CallPattern(opt, arg, d(j, r))

def decl(seq):
    p = seq.parse(profile)
    return lambda j, r: CommandDecl(p, j, r)

def profile(seq):
    i = typedef(seq)
    _ = seq.parse('->')
    o = typedef(seq)
    return [(i, o)]

def jump(seq):
    return seq.parse([throws, breaks])

def throws(seq):
    _ = seq.parse('throws ')
    return _, seq.parse([lambda s: [typedef(s)], typelist])

def breaks(seq):
    _ = seq.parse('breaks ')
    return _, seq.parse([lambda s: [typedef(s)], typelist])

def typelist(seq):
    _ = seq.parse('[')
    r = chain_flat(typedef, comma)(seq)
    _ = seq.parse(']')
    return r

def namelist(seq):
    _ = seq.parse('[')
    r = chain_flat(name, comma)(seq)
    _ = seq.parse(']')
    return r

def resource(seq):
    return seq.parse([uses, reads, updates])

def updates(seq):
    _ = seq.parse('uses ')
    return _.strip(), seq.parse([lambda s:[name(s)], namelist])

def reads(seq):
    _ = seq.parse('reads ')
    return _.strip(), seq.parse([lambda s:[name(s)], namelist])

def uses(seq):
    _ = seq.parse('updates ')
    return _.strip(), seq.parse([lambda s:[name(s)], namelist])

def refers(seq):
    _ = seq.parse('refers ')
    l = seq.parse(Regex(r'[a-zA-Z]+:'))
    return l, seq.parse(Regex(r'([a-zA-Z][a-zA-Z0-9]*(\.[a-zA-Z][a-zA-Z0-9]*)*)'))

