#coding : utf-8
class ResouceFinder(object):
    u"""リソース探索オブジェクト。
    Caty では基本的にサイト間のリソースは隔離されており、
    他のサイトのコマンド、スキーマなどを取得することはできない。
    ただし、以下のリソースは他のサイトのものを参照できた方が都合が良い。

    * コマンド
    * スキーマ
    * スクリプト
    * テンプレート

    公開ディレクトリなどは直接の参照を許さず、参照する場合はコマンドを経由する。

    すべての Caty ファシリティは ResourceFinder への参照を持ち、
    必要に応じて適切なリソースが取得できるようにする。

    ResourceFinder は一つの Caty アプリケーションにおいてただ一つだけのインスタンスが作成される。
    """

    def __init__(self):
      self._facility_sets = {}  

    def add_faclity_set(self, site_name, faclity_set):
        self._faclity_sets[site_name] = facility_set

    def get_resource(self, site_name, resource_name):
        return self._facility_sets[site_name][resource_name]

    def get_faclity_set(self, site_name):
        return self._facility_sets[site_name]

