#coding: utf-8
from caty.core.schema.base import *

class BoolSchema(ScalarSchema):

    def _validate(self, value):
        if not self.optional and value == None:
            raise JsonSchemaError(u'null は許可されていません')
        elif self.optional and value == None:
            return
        if not isinstance(value, bool):
            raise JsonSchemaError(u'値は真偽値でなければなりません')

    def _convert(self, value):
        if value == 'true': return True
        if value == 'false': return False
        raise JsonSchemaError(u'値はtrue/falseでなければなりません: %s' % value, value, '')

    def intersect(self, another):
        return self.clone()

    def dump(self, depth, node=[]):
        return 'boolean'

    @property
    def type(self):
        return 'boolean'

