from topdown import *
from creole.syntax.base import WikiParser

class Anchor(WikiParser):
    def __init__(self, wiki_url, factory=None):
        self.wiki_url = wiki_url if (wiki_url.endswith('/') or wiki_url == '') else wiki_url + '/'
        self.start = '[['
        self.end = ']]'
        WikiParser.__init__(self, factory)

    def __call__(self, seq, start):
        url = seq.parse(until([']]', '|']))
        if seq.current == '|':
            seq.parse('|')
            text = seq.parse(until(']]'))
            seq.parse(']]')
            if url.startswith('>'):
                url = url[1:]
                target = '_blank'
                attr = [('href', url), ('target', 'blank')]
            else:
                attr = [('href', url)]
        else:
            seq.parse(']]')
            if url.startswith('>'):
                url = url[1:]
                target = '_blank'
                attr = [('href', self.wiki_url + url), ('target', 'blank')]
            else:
                attr = [('href', self.wiki_url + url)]
            text = url
        return self.create_element('a', attr, [text])

