#!/bin/sh

if [ "$1" = "" ]; then
    echo
    echo Usage: $0 projectdir
    echo
    exit 1
fi

if [ "$CATY_HOME" = "" ]; then
    _CATY_HOME=.
else
    _CATY_HOME="$CATY_HOME"
fi

projectdir="$1"
files='_global.xjson caty.py'
# python/ only
# add directories if you need
dirs='python lib' 

if [ ! -d  "$projectdir" ]; then
    echo
    echo "cannot find directory $projectdir"
    echo
    exit 1
fi

for f in $files; do cp --verbose --update "$_CATY_HOME/$f" "$projectdir"; done
for d in $dirs;  do cp --verbose --update --recursive "$_CATY_HOME/$d" "$projectdir/"; done
